/*--------------------------------------------------------------------------------
    ooo      L   attice-based  |
  o\.|./o    e   xtensible     | LeMonADE: An Open Source Implementation of the
 o\.\|/./o   Mon te-Carlo      |           Bond-Fluctuation-Model for Polymers
oo--GPU--oo  A   lgorithm and  |
 o/./|\.\o   D   evelopment    | Copyright (C) 2013-2015 by
  o/.|.\o    E   nvironment    | LeMonADE Principal Developers (see AUTHORS)
    ooo                        |
----------------------------------------------------------------------------------

This file is part of LeMonADEGPU.

LeMonADE is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

LeMonADE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LeMonADE.  If not, see <http://www.gnu.org/licenses/>.

--------------------------------------------------------------------------------*/
#include <LeMonADEGPU/core/BondVectorSet.h>

void BondVectorSet::initBondTable(){
  /* create the BondTable and copy it to constant memory */
  bool * tmpForbiddenBonds = (bool*) malloc( sizeof( bool ) * 512 );
  unsigned nAllowedBonds = 0;
  for ( int i = 0; i < 512; ++i )
      if ( ! ( tmpForbiddenBonds[i] = mForbiddenBonds[i] ) )
	  ++nAllowedBonds;
  /* Why does it matter? Shouldn't it work with arbitrary bond sets ??? */
  if ( nAllowedBonds != 108 )
  {
      std::stringstream msg;
      msg << "[" << __FILENAME__ << "::initializeBondTable] "
	  << "Wrong bond-set! Expected 108 allowed bonds, but got " << nAllowedBonds << "\n";
      throw std::runtime_error( msg.str() );
  }
  CUDA_ERROR( cudaMemcpyToSymbol( dpForbiddenBonds, tmpForbiddenBonds, sizeof(bool)*512 ) );
    free( tmpForbiddenBonds );
}